# -*- coding: utf-8 -*-

import pygst
pygst.require("0.10")
import gst, gobject
gobject.threads_init()

import sys, array, time, Ice, IceStorm
Ice.loadSlice("-I/usr/share/slice --all /usr/share/gstice/slice/gstice.ice")
import GSTICE

class iByteSeq_I(GSTICE.iByteSeq.W):
    def __init__(self, src):
        self.s = src

    def set(self, buffer, current=None):
        sys.stdout.write(".")
        sys.stdout.flush()

        self.s.data.fromlist(buffer)

class gstIceSrc(gst.BaseSrc):

    __gsttemplates__ = (
        gst.PadTemplate("src",
                        gst.PAD_SRC,
                        gst.PAD_ALWAYS,
                        gst.caps_new_any()),
        )

    data = array.array("B")

    def __init__(self, name):
        self.__gobject_init__()
        self.set_name(name)
        self.com = None

        self.adapter_endp = None
        self.topic_mgr_endp = None
        self.topic_name = None

    def run(self):
        if not (self.topic_name):
            raise Exception, "You must set the 'topic' property"
        if not (self.adapter_endp):
            raise Exception, "You must set the 'adapter' property"
        if not (self.topic_mgr_endp):
            raise Exception, "You must set the 'topic-manager' property"

        
        self.com = Ice.initialize([])

        adapter = self.com.createObjectAdapterWithEndpoints("Adapter", self.adapter_endp)
        adapter.activate()
        servant = iByteSeq_I(self)
        prx = adapter.add(servant, Ice.stringToIdentity("servant"))
        prx = prx.ice_datagram()

        obj = self.com.stringToProxy(self.topic_mgr_endp)

        print "Connecting to IceStorm at %s..." % self.topic_mgr_endp
        tpcMgr = IceStorm.TopicManagerPrx.checkedCast(obj)

        try:
            topic = tpcMgr.retrieve(self.topic_name)
        except IceStorm.NoSuchTopic:
            topic = tpcMgr.create(self.topic_name)

        topic.subscribe({}, prx)
        print prx
                
    def do_create(self, offset, size):
        if not self.com:
            self.run()

        while self.data.buffer_info()[1] < size:
            time.sleep(0.01)
            
        ret = gst.Buffer(self.data[:size])
        self.data = self.data[size:]
        ret.offset = offset
        return gst.FLOW_OK, ret

    def set_property(self, key, value):
        if key == "topic-manager":
            self.topic_mgr_endp = value
        elif key == "topic":
            self.topic_name = value
        elif key == "adapter":
            self.adapter_endp = value
        else:
            gst.BaseSrc.set_property(self, key, value)
            
    def get_property(self, key):
        try:
            return self.__dict__[key]
        except KeyError:
            return gst.BaseSrc.get_property(self, key)    

gobject.type_register(gstIceSrc)
