# Simple Video Player

import pygst
pygst.require("0.10")
import sys, gst, gobject

# Main function, it does everything.
def main(args):
    
    # Fist of all, we need the name of the file to play
    # and only that, no more.
    if len(args) != 2:
        print "Usage: "+args[0]+" <video file>"
        sys.exit(-1)

    #pipestr = 'filesrc location='+args[1]+' ! oggdemux name=decoder decoder. ! theoradec ! xvimagesink decoder. ! vorbisdec ! audioconvert ! alsasink'
    pipestr = 'filesrc location='+args[1]+' ! decodebin name=decoder decoder. ! ffmpegcolorspace ! xvimagesink decoder. ! audioconvert ! alsasink'

    # create a new bin to hold the elements, and create
    # the elements to hold.
    try:
        pipeline = gst.parse_launch(pipestr)
    except gobject.GError, e:
        print "could not create pipeline, " +str(e)
        sys.exit(-1)
        
    # And we put it to dance...
    pipeline.set_state(gst.STATE_PLAYING)

    # Then, the main loop.
    loop = gobject.MainLoop()

    def events(bus, msg):
        t = msg.type
        if t == gst.MESSAGE_EOS: # En Of Stream
            loop.quit()
            
        elif t == gst.MESSAGE_ERROR:
            e, d = msg.parse_error()
            print "ERROR:",e
            loop.quit()
        
        return True    

    # A watch for handle events.
    pipeline.get_bus().add_watch(events)

    # Start all.
    try:
        print "Playing..."    
        loop.run()
        
    except KeyboardInterrupt: # if you press Ctrl+C
        pass
    
    print "Stopping...\nBye!"

    # Once the file is played, we go out
    pipeline.set_state(gst.STATE_NULL)
    return 0

if __name__ == "__main__":
    sys.exit(main(sys.argv))
